unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls, TabNotBk;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Status: TStatusBar;
    PbEditor: TPaintBox;
    Panel2: TPanel;
    ScrollH: TScrollBar;
    Bevel1: TBevel;
    ScrollV: TScrollBar;
    procedure PbEditorPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ScrollHChange(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var
    FLine: string;          //  Ǘ镶(̓NX̃o[)
    FCharWidth: integer;    //  1oCg̕
    FCharHeight: integer;   //  1s̍
    FCurrentRow: integer;   //  ݍs(̃Tvł͉iv0s)
    FCurrentCol: integer;   //  ݗ

//-----------------------------------------------------------------------------
//  J[\ʒu̒O̕1oCgłH(͈̓`FbNȂ)
function PrevCharIsSingle(): Boolean;
begin
    Result := (ByteType(FLine, FCurrentCol) = mbSingleByte);
end;

//-----------------------------------------------------------------------------
//  J[\ʒu̒̕1oCgłH(͈̓`FbNȂ)
function NextCharIsSingle(): Boolean;
begin
    Result := (ByteType(FLine, FCurrentCol + 1) = mbSingleByte);
end;

//-----------------------------------------------------------------------------
//  tH[NGCg
procedure TForm1.FormCreate(Sender: TObject);
begin
    //  tHgݒ
    PbEditor.Canvas.Font.Assign(Self.Font);
    //  ՂȂr@
    PbEditor.ControlStyle := PbEditor.ControlStyle + [csOpaque];

    //  ҏW̕
    FLine := '0123456789Tv0123456789Tv';
    //  1oCg̕߂ĂBłɁB
    //  ۂɂ̓tHgύXꂽƂȂǂɂvZȂB
    //  GfB^Ńv|[VitHgȂǋB
    FCharWidth := PbEditor.Canvas.TextWidth('W');
    FCharHeight := PbEditor.Canvas.TextHeight('Wg');
    //  ݍs
    FCurrentRow := 0;
    //  ݗ
    FCurrentCol := 0;
end;

//-----------------------------------------------------------------------------
//  ̕`
procedure TForm1.PbEditorPaint(Sender: TObject);
var
    OffsetX, OffsetY: integer;
    i, PosX, PosY: integer;
    MbType: TMbcsByteType;
begin
    OffsetX := PbEditor.Left;
    OffsetY := PbEditor.Top;

    //  wiF͔ŁB
    PbEditor.Canvas.Brush.Color := clWhite;
    //  hԂ
    PbEditor.Canvas.FillRect(PbEditor.ClientRect);

    //  `(1)
//    PosX := 0;
    PosX := 0 - ScrollH.Position * FCharWidth;
    PosY := 0;
    for i := 1 to Length(FLine) do
    begin
        //  oCg^Cv́H
        MbType := ByteType(FLine, i);
        //  1oCgȂ炻̂܂
        if (MbType = mbSingleByte) then
        begin
            PbEditor.Canvas.TextOut(PosX, PosY, FLine[i]);
            Inc(PosX, FCharWidth);
        end
        //  2oCg2oCgڂȂ
        else if (MbType = mbTrailByte) then
        begin
            //  1O̕ƍ킹
            PbEditor.Canvas.TextOut(PosX, PosY, FLine[i - 1] + FLine[i]);
            Inc(PosX, 2 * FCharWidth);
        end;
    end;

    //  IME̕ϊEBhËʒuݒ
//    PosX := FCurrentCol * FCharWidth;
    PosX := (FCurrentCol - ScrollH.Position) * FCharWidth;
    PosY := FCurrentRow * FCharHeight;
    SetImeCompositionWindow(PbEditor.Canvas.Font, OffsetX + PosX, OffsetY + PosY);

    //  J[\`
    PbEditor.Canvas.MoveTo(PosX, PosY);
    PbEditor.Canvas.LineTo(PosX, PosY + FCharHeight);

    //  Xe[^Xo[Ɉʒu\
    Status.Panels[0].Text := Format('%3ds %3d', [FCurrentRow + 1, FCurrentCol + 1]);
    Status.Panels[1].Text := Format('%3d', [ScrollH.Position + 1]);
end;

//-----------------------------------------------------------------------------
//  Đ䕶H
function iscntrl(const c: char): Boolean;
begin
    Result := Ord(c) in [$00..$1F, $7F];
end;

//-----------------------------------------------------------------------------
//  L[{[h(KeyPreview = true ɂĂ)
procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
    //  }\ȃL[̏ꍇ(K)
    if not iscntrl(Key) then
    begin
        //  ݗɕ}
        Insert(Key, FLine, FCurrentCol + 1);
        //  ݗi߂
        Inc(FCurrentCol);
    end
    //  Back Space
    else if (Ord(Key) = VK_BACK) then
    begin
        if (FCurrentCol > 0) then
        begin
            //  폜Ώۂ1oCgǂ
            if PrevCharIsSingle() then
            begin
                //  ݗ̑O̕폜
                Delete(FLine, FCurrentCol, 1);
                //  ݗ߂
                Dec(FCurrentCol);
            end
            else
            begin
                //  ݗ̑O̕폜
                Delete(FLine, FCurrentCol - 1, 2);
                //  ݗ߂
                Dec(FCurrentCol, 2);
            end;
        end;
    end;
    //  ĕ`
    PbEditor.Invalidate();
end;

//-----------------------------------------------------------------------------
//  L[
procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    case Key of

    //  ړ
    VK_LEFT:    if (FCurrentCol > 0) then
                begin
                    if PrevCharIsSingle() then
                        Dec(FCurrentCol)
                    else
                        Dec(FCurrentCol, 2);
                end;
    //  Eړ
    VK_RIGHT:   if (FCurrentCol < Length(FLine)) then
                begin
                    if NextCharIsSingle() then
                        Inc(FCurrentCol)
                    else
                        Inc(FCurrentCol, 2);
                end;
    //  DELETE
    VK_DELETE:  //  ݗ̎̕폜
                if NextCharIsSingle() then
                    Delete(FLine, FCurrentCol + 1, 1)
                else
                    Delete(FLine, FCurrentCol + 1, 2);

    //  HOME
    VK_HOME:    FCurrentCol := 0;

    //  END
    VK_END:     FCurrentCol := Length(FLine);

    end;
    //  ĕ`
    PbEditor.Invalidate();
end;

//-----------------------------------------------------------------------------
//  XN[
procedure TForm1.ScrollHChange(Sender: TObject);
begin
    //  ĕ`
    PbEditor.Invalidate();
end;

end.

